glibmm 2.4: Glib::FileError Class Reference

Main Page Widgets glibmm Namespaces Book

# Glib::FileError Class Reference
[File Utilities]

Exception class for file-related errors. More...

Inheritance diagram for Glib::FileError:

[legend]
List of all members.

## Public Types
enum | Code { EXISTS, IS_DIRECTORY, ACCESS_DENIED, NAME_TOO_LONG, NO_SUCH_ENTITY, NOT_DIRECTORY, NO_SUCH_DEVICE, NOT_DEVICE, READONLY_FILESYSTEM, TEXT_FILE_BUSY, FAULTY_ADDRESS, SYMLINK_LOOP, NO_SPACE_LEFT, NOT_ENOUGH_MEMORY, TOO_MANY_OPEN_FILES, FILE_TABLE_OVERFLOW, BAD_FILE_DESCRIPTOR, INVALID_ARGUMENT, BROKEN_PIPE, TRYAGAIN, INTERRUPTED, IO_ERROR, NOT_OWNER, NOSYS, FAILED }
| Values corresponding to `errno` codes returned from file operations on UNIX. More...
## Public Member Functions
| FileError (Code error_code, const Glib::ustring& error_message)
| FileError (GError* gobject)
Code | code () const

## Detailed Description

Exception class for file-related errors.

## Member Enumeration Documentation

enum Glib::FileError::Code

Values corresponding to `errno` codes returned from file operations on UNIX.

Unlike `errno` codes, FileError::Code values are available on all systems, even Windows. The exact meaning of each code depends on what sort of file operation you were performing; the UNIX documentation gives more details. The following error code descriptions come from the GNU C Library manual, and are under the copyright of that manual.

It's not very portable to make detailed assumptions about exactly which errors will be returned from a given operation. Some errors don't occur on some systems, etc., sometimes there are subtle differences in when a system will report a given error, etc.

Enumerator:

  EXISTS | `(EEXIST)` Operation not permitted; only the owner of the file (or other resource) or processes with special privileges can perform the operation.
  IS_DIRECTORY | `(EISDIR)` File is a directory; you cannot open a directory for writing, or create or remove hard links to it.
  ACCESS_DENIED | `(EACCES)` Permission denied; the file permissions do not allow the attempted operation.
  NAME_TOO_LONG | `(ENAMETOOLONG)` Filename too long.
  NO_SUCH_ENTITY | `(ENOENT)` No such file or directory. This is a "file doesn't exist" error for ordinary files that are referenced in contexts where they are expected to already exist.
  NOT_DIRECTORY | `(ENOTDIR)` A file that isn't a directory was specified when a directory is required.
  NO_SUCH_DEVICE | `(ENXIO)` No such device or address. The system tried to use the device represented by a file you specified, and it couldn't find the device. This can mean that the device file was installed incorrectly, or that the physical device is missing or not correctly attached to the computer.
  NOT_DEVICE | `(ENODEV)` This file is of a type that doesn't support mapping.
  READONLY_FILESYSTEM | `(EROFS)` The directory containing the new link can't be modified because it's on a read-only file system.
  TEXT_FILE_BUSY | `(ETXTBSY)` Text file busy.
  FAULTY_ADDRESS | `(EFAULT)` You passed in a pointer to bad memory. (Glib won't reliably return this, don't pass in pointers to bad memory.)
  SYMLINK_LOOP | `(ELOOP)` Too many levels of symbolic links were encountered in looking up a file name. This often indicates a cycle of symbolic links.
  NO_SPACE_LEFT | `(ENOSPC)` No space left on device; write operation on a file failed because the disk is full.
  NOT_ENOUGH_MEMORY | `(ENOMEM)` No memory available. The system cannot allocate more virtual memory because its capacity is full.
  TOO_MANY_OPEN_FILES | `(EMFILE)` The current process has too many files open and can't open any more. Duplicate descriptors do count toward this limit.
  FILE_TABLE_OVERFLOW | `(ENFILE)` There are too many distinct file openings in the entire system.
  BAD_FILE_DESCRIPTOR | `(EBADF)` Bad file descriptor; for example, I/O on a descriptor that has been closed or reading from a descriptor open only for writing (or vice versa).
  INVALID_ARGUMENT | `(EINVAL)` Invalid argument. This is used to indicate various kinds of problems with passing the wrong argument to a library function.
  BROKEN_PIPE | `(EPIPE)` Broken pipe; there is no process reading from the other end of a pipe. Every library function that returns this error code also generates a `SIGPIPE` signal; this signal terminates the program if not handled or blocked. Thus, your program will never actually see this code unless it has handled or blocked `SIGPIPE`.
  TRYAGAIN | `(EAGAIN)` Resource temporarily unavailable; the call might work if you try again later. We used TRYAGAIN instead of TRY_AGAIN, because that is a defined as a macro by a Unix header.
  INTERRUPTED | `(EINTR)` Interrupted function call; an asynchronous signal occurred and prevented completion of the call. When this happens, you should try the call again.
  IO_ERROR | `(EIO)` Input/output error; usually used for physical read or write errors. I.e. the disk or other physical device hardware is returning errors.
  NOT_OWNER | `(EPERM)` Operation not permitted; only the owner of the file (or other resource) or processes with special privileges can perform the operation.
  NOSYS |
  FAILED | Does not correspond to a UNIX error code; this is the standard "failed for unspecified reason" error code present in all Glib::Error error code enumerations. Returned if no specific code applies.

## Constructor & Destructor Documentation

Glib::FileError::FileError | ( | Code | error_code,
|  | const Glib::ustring& | error_message |
| ) |  |  |

Glib::FileError::FileError | ( | GError * | gobject | ) | `[explicit]`

## Member Function Documentation

Code Glib::FileError::code | ( |  | ) | const

Reimplemented from Glib::Error.

The documentation for this class was generated from the following file:

- fileutils.h